version: '3.8'

services:
  mysql:
    image: mysql:8.0
    environment:
      MYSQL_ROOT_PASSWORD: rootpassword
      MYSQL_DATABASE: crowdfunding_db
      MYSQL_USER: user
      MYSQL_PASSWORD: pass
    ports:
      - "3306:3306"
    volumes:
      - mysql_data:/var/lib/mysql
      - ./init_db:/docker-entrypoint-initdb.d
    healthcheck:
      test: ["CMD-SHELL", "mysqladmin ping -u root -prootpassword"]
      interval: 10s
      timeout: 5s
      retries: 5

  nestjs:
    build: .
    depends_on:
      mysql:
        condition: service_healthy
    environment:
      - DB_HOST=mysql
      - DB_PORT=3306
      - DB_USERNAME=user
      - DB_PASSWORD=pass
      - DB_DATABASE=crowdfunding_db
      - JWT_SECRET=0f83915ae1051dcbef2e436d66e005630d9d1c0a997513b13506dbd7f7005c8d
    ports:
      - "4000:4000"
volumes:
  mysql_data:
